package xyz.lychee.lagfixer.libs.adventure.text;

import java.util.stream.Stream;
import xyz.lychee.lagfixer.libs.annotations.Contract;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;
import xyz.lychee.lagfixer.libs.examination.ExaminableProperty;

public interface SelectorComponent extends BuildableComponent<SelectorComponent, Builder>, ScopedComponent<SelectorComponent> {
   @NotNull String pattern();

   @Contract(
      pure = true
   )
   @NotNull SelectorComponent pattern(final @NotNull String pattern);

   @Nullable Component separator();

   @NotNull SelectorComponent separator(final @Nullable ComponentLike separator);

   default @NotNull Stream<? extends ExaminableProperty> examinableProperties() {
      return Stream.concat(Stream.of(ExaminableProperty.of("pattern", this.pattern()), ExaminableProperty.of("separator", this.separator())), BuildableComponent.super.examinableProperties());
   }

   public interface Builder extends ComponentBuilder<SelectorComponent, Builder> {
      @Contract("_ -> this")
      @NotNull
      @NotNull Builder pattern(final @NotNull String pattern);

      @Contract("_ -> this")
      @NotNull
      @NotNull Builder separator(final @Nullable ComponentLike separator);
   }
}
